#pragma once
#ifndef __ia32error_h__
#define __ia32error_h__

#include "ia32def.h"

class ia32error
{
public:

	enum err_
	{
		err_generic,
		err_ring0_cpu,
		err_ring0_create,
		err_ring0_ioctl,
		err_ring0_size,
		err_ring0_close,
		err_counter_overflow,
		err_counter_family,
		err_counter_MMX,
		err_counter_SSE,
		err_counter_counter,
		err_invalid
	};

	ia32error (err_ v) : v(v)
	{
	}

	operator const char * () const
	{
		static const char *messages[] = 
		{
			"Generic fault",
			"Ring-0: Wrong processor",
			"Ring-0: CreateFile failed",
			"Ring-0: DeviceIOControl failed",
			"Ring-0: DeviceIOControl returned wrong result",
			"Ring-0: CloseHandle failed",
			"Counter: Too many counters created",
			"Counter: Wrong processor family",
			"Counter: MMX not available",
			"Counter: SSE not available",
			"Counter: Wrong counter index"
		};
		
		return messages[v < err_invalid ? v : err_generic];
	}

protected:

	err_ v;
};

#endif