#pragma once
#ifndef __ia32size_h__
#define __ia32size_h__

#include "ia32def.h"

#define B	((uint64)1)
#define KB	(B * 1024)
#define MB	(KB * 1024)
#define GB	(MB * 1024)
#define TB	(GB * 1024)

class ia32size
{
	uint64	size;

public:
	ia32size(uint64 size) : 
		size(size)
	{
	}

	operator const string () const
	{
		uint64 size = this->size;
		char *scale = " KMGT";
		int index = 0;

		while (size > 0 && size % 1024 == 0)
		{
			size /= 1024;
		
			index++;
		}

		char b[64];

		string d = _i64toa(size, b, 10);

		return d + scale[index] + "B";
	}

	operator const uint64 () const
	{
		return size;
	}
};

#endif