#include "ia32.h"

const ia32cache ia32caches[] =
{
	ia32cache(0x00, ia32cache::type_reserved, 0, 0, 0, 0),
	ia32cache(0x01, ia32cache::type_instruction, ia32cache::level_TLB, 32, 4 * KB, 4),
	ia32cache(0x02, ia32cache::type_instruction, ia32cache::level_TLB, 2, 4 * MB, ia32cache::associativity_Full),
	ia32cache(0x03, ia32cache::type_data, ia32cache::level_TLB, 64, 4 * KB, 4),
	ia32cache(0x04, ia32cache::type_data, ia32cache::level_TLB, 8, 4 * MB, 4),
	ia32cache(0x06, ia32cache::type_instruction, 1, 8 * KB, 32, 4),
	ia32cache(0x08, ia32cache::type_instruction, 1, 16 * KB, 32, 4),
	ia32cache(0x0A, ia32cache::type_data, 1, 8 * KB, 32, 2),
	ia32cache(0x0C, ia32cache::type_data, 1, 16 * KB, 32, 4),
	ia32cache(0x22, ia32cache::type_unified, 3, 512 * KB, 64, 4),
	ia32cache(0x23, ia32cache::type_unified, 3, 1 * MB, 64, 8),
	ia32cache(0x25, ia32cache::type_unified, 3, 2 * MB, 64, 8),
	ia32cache(0x29, ia32cache::type_unified, 3, 4 * MB, 64, 8),
	ia32cache(0x40, ia32cache::type_reserved, 0, 0, 0, 0),
	ia32cache(0x41, ia32cache::type_unified, 2, 128 * KB, 32, 4),
	ia32cache(0x42, ia32cache::type_unified, 2, 256 * KB, 32, 4),
	ia32cache(0x43, ia32cache::type_unified, 2, 512 * KB, 32, 4),
	ia32cache(0x44, ia32cache::type_unified, 2, 1 * MB, 32, 4),
	ia32cache(0x45, ia32cache::type_unified, 2, 2 * MB, 32, 4),
	ia32cache(0x50, ia32cache::type_instruction, ia32cache::level_TLB, 64, ia32cache::block_AnySize, ia32cache::associativity_Full),
	ia32cache(0x51, ia32cache::type_instruction, ia32cache::level_TLB, 128, ia32cache::block_AnySize, ia32cache::associativity_Full),
	ia32cache(0x52, ia32cache::type_instruction, ia32cache::level_TLB, 256, ia32cache::block_AnySize, ia32cache::associativity_Full),
	ia32cache(0x5B, ia32cache::type_data, ia32cache::level_TLB, 64, ia32cache::block_AnySize, ia32cache::associativity_Full),
	ia32cache(0x5C, ia32cache::type_data, ia32cache::level_TLB, 64, ia32cache::block_AnySize, ia32cache::associativity_Full),
	ia32cache(0x5D, ia32cache::type_data, ia32cache::level_TLB, 64, ia32cache::block_AnySize, ia32cache::associativity_Full),
	ia32cache(0x66, ia32cache::type_data, 1, 8 * KB, 64, 4),
	ia32cache(0x67, ia32cache::type_data, 1, 16 * KB, 64, 4),
	ia32cache(0x68, ia32cache::type_data, 1, 32 * KB, 64, 4),
	ia32cache(0x70, ia32cache::type_trace, 1, 12 * KB, 0, 8),	
	ia32cache(0x71, ia32cache::type_trace, 1, 16 * KB, 0, 8),	
	ia32cache(0x72, ia32cache::type_trace, 1, 32 * KB, 0, 8),
	ia32cache(0x79, ia32cache::type_unified, 2, 128 * KB, 128, 8), 
	ia32cache(0x7A, ia32cache::type_unified, 2, 256 * KB, 128, 8), 
	ia32cache(0x7B, ia32cache::type_unified, 2, 512 * KB, 128, 8), 
	ia32cache(0x7C, ia32cache::type_unified, 2, 1 * MB, 128, 8), 
	ia32cache(0x82, ia32cache::type_unified, 2, 256 * KB, 32, 8), 
	ia32cache(0x83, ia32cache::type_unified, 2, 512 * KB, 32, 8), 
	ia32cache(0x84, ia32cache::type_unified, 2, 1 * MB, 32, 8), 
	ia32cache(0x85, ia32cache::type_unified, 2, 2 * MB, 32, 8)
};

const ia32cache &_ia32cache (byte descriptor)
{
	for (int i = sizeof(ia32caches) / sizeof(ia32caches[0]); i > 0; i--)
		if (descriptor == ia32caches[i].descriptor)
			return ia32caches[i];

	return ia32caches[0];
}