#include "ring0.h"

typedef union
{
	uint64 value;

	struct
	{
		uint32 lo;
		uint32 hi;
	};
} suint64;

void setup ()
{
	__asm
	{
		_emit 0x0F; // mov	eax, cr4
		_emit 0x20;
		_emit 0xE0;

		or	eax, 0x00000100;
		and	eax, 0xFFFFFFFB;

		_emit 0x0F; // mov	cr4, eax
		_emit 0x22;
		_emit 0xE0;
	}
}

void wrmsr (uint32 i, uint64 d)
{
	suint64 data = {d};

	__try
	{
		__asm
		{
			mov	ecx, i;
			mov eax, data.lo;
			mov edx, data.hi;
			wrmsr;
		}
	}
	__except (1)
	{
	}
}

uint64 rdmsr (uint32 i)
{
	suint64 data;

	__try
	{
		__asm
		{
			mov	ecx, i;
			rdmsr;
			mov	data.lo, eax;
			mov data.hi, edx;
		}
	}
	__except (1)
	{
		return 0;
	}

	return data.value;
}